<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$_CUR = 'partner';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';
 
// 合作伙伴上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/partner/'); // 实例化类文件(文件上传路径，结尾加斜杠)
                                                        
// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('ur_here', $_LANG['partner']);
$smarty->assign('partner_list', get_partner_list());

/**
 * +----------------------------------------------------------
 * 合作伙伴列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    $smarty->display('partner.htm');
} 

/**
 * +----------------------------------------------------------
 * 合作伙伴添加处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'insert') {
    // 验证合作伙伴名称
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['partner_name'] . $_LANG['is_empty']);
    
    // 验证是否上传合作伙伴
    if (empty($_FILES['image']['name'])) $dou->dou_msg($_LANG['partner_image'] . $_LANG['is_empty']);

    // 文件上传盒子
    $image = $file->box('partner', $dou->auto_id('partner'), 'image', 'main');

    // 格式化数据
    $add_time = time();

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "INSERT INTO " . $dou->table('partner') . " (id, name, image, add_time, sort)" . " VALUES (NULL, '$_POST[name]', '$image', '$add_time', '$_POST[sort]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['partner_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['partner_add_succes'], 'partner.php');
} 

/**
 * +----------------------------------------------------------
 * 合作伙伴编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $partner = $dou->get_row('partner', '*', "id = '$id'");
    
    // 格式化数据
    $partner['image'] = $dou->dou_file($partner['image']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('partner', $partner);
    
    $smarty->display('partner.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证合作伙伴名称
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['partner_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('partner', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "update " . $dou->table('partner') . " SET name='$_POST[name]'" . $image . " , sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    $dou->create_admin_log($_LANG['partner_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['partner_edit_succes'], 'partner.php');
} 

/**
 * +----------------------------------------------------------
 * 文件盒子
 * +----------------------------------------------------------
 */
elseif ($rec == 'filebox') {
    // 验证并获取合法的REQUEST
    $id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : '';
    $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : '';
    
    // 文件上传盒子
    $custom_filename = $id . '_' . $type . '_' . $dou->create_rand_string('number', 6, time());
    $image = $file->box('partner', $id, $type . '_file', $type, $custom_filename);
    $file_url = $dou->dou_file($image);
    $img = '<img src="' . $file_url. '" data-file="' . $image . '" />';
    
    echo $img;
}

/**
 * +----------------------------------------------------------
 * 合作伙伴删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'partner.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('partner') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        // 删除相应商品合作伙伴
        $image = $dou->get_one("SELECT image FROM " . $dou->table('partner') . " WHERE id = '$id'");
        $dou->del_file($image);
        
        $dou->create_admin_log($_LANG['partner_del'] . ': ' . $name);
        $dou->delete('partner', "id = $id", 'partner.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'partner.php', '', '30', "partner.php?rec=del&id=$id");
    }
}
    
/**
 * +----------------------------------------------------------
 * 获取合作伙伴列表
 * +----------------------------------------------------------
 */
function get_partner_list() {
    $sql = "SELECT * FROM " . $GLOBALS['dou']->table('partner'). " ORDER BY sort ASC, id ASC";
    $query = $GLOBALS['dou']->query($sql);
    while ($row = $GLOBALS['dou']->fetch_array($query)) {
        $partner_list[] = array (
                "id" => $row['id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "add_time" => $row['add_time'],
                "sort" => $row['sort'] 
        );
    }
    
    return $partner_list;
}
?>